Bug 19718

Summary: Create message for patrons with multiple holds on the same item
Product: Koha Reporter: Karen <karen>
Component: Hold requestsAssignee: Nick Clemens <nick>
Status: RESOLVED FIXED QA Contact: Testopia <testopia>
Severity: enhancement    
Priority: P5 - low CC: bibliwho, gmcharlt, jonathan.druart, joy, katrin.fischer, lisetteslatah, liz, nick
Version: master   
Hardware: All   
OS: All   
Change sponsored?: --- Patch complexity: Trivial patch
Who signed the patch off: Text to go in the release notes:
Version(s) released in:
20.05.00
Attachments: Bug 19718: Show message if patron has existing holds on a title
Bug 19718: Show message if patron has existing holds on a title
Bug 19718: (follow-up) Make messages translatable
Bug 19718: Show message if patron has existing holds on a title
Bug 19718: (follow-up) Make messages translatable

Description Karen 2017-11-29 22:18:40 UTC
One of our partners allows 3 holds per record. They have noticed that patrons will place multiple holds on an item that they have already placed on hold. 

They would like for Koha to display a message to the patron when they place a hold on an item they already have on hold. Their suggested message is "You already have placed a hold on this record. Are you sure you want to place another?"
Comment 1 Lisette Scheer 2017-12-07 22:54:08 UTC
We also have had this problem a lot. Many of our older patrons will place a hold and then place an additional hold a couple weeks later when it has not yet arrived for them.
Comment 2 Liz Rea 2017-12-13 20:43:39 UTC
So maybe what you'd like is the ability to allow multiple holds per branch or per user category, so that if someone else had allowed multiple holds, you wouldn't be required to?
Comment 3 Cab Vinton 2019-08-27 13:51:51 UTC
Having trouble following Liz's suggestion, but we have the same issue as Karen & Lisette.

Karen's idea for a warning message seems like a good one to us. 

Sometimes a patron will have a very good reason for placing multiple holds on the same record (teacher wanting multiple copies, Vol.'s 1 & 2 cataloged on the same record, etc.) Other times, a patron will only want a single item but will  have simply forgotten that they've already placed a hold.
Comment 4 Nick Clemens 2019-08-28 11:54:29 UTC
Created attachment 92489 [details] [review]
Bug 19718: Show message if patron has existing holds on a title

To test:
 1 - Set a rule to allow multiple holds on a title
 2 - Place a single hold in the opac for a patron
 3 - Return to record and attempt place a second hold
 4 - Note there is no message but that you must match the type placed before (item or record level)
 5 - Don't place the hold
 6 - Apply patch
 7 - Attempt to place second hold again
 8 - Note there is a message informing you of which level hold you may place
 9 - Test with both item/record level holds and placing a single request or multiple requests
Comment 5 ByWater Sandboxes 2019-11-06 18:13:26 UTC
Created attachment 95120 [details] [review]
Bug 19718: Show message if patron has existing holds on a title

To test:
 1 - Set a rule to allow multiple holds on a title
 2 - Place a single hold in the opac for a patron
 3 - Return to record and attempt place a second hold
 4 - Note there is no message but that you must match the type placed before (item or record level)
 5 - Don't place the hold
 6 - Apply patch
 7 - Attempt to place second hold again
 8 - Note there is a message informing you of which level hold you may place
 9 - Test with both item/record level holds and placing a single request or multiple requests

Signed-off-by: donnab <donna@bywatersolutions.com>
Comment 6 Katrin Fischer 2019-11-24 13:56:29 UTC
Switching to Signed off - the sandbox doesn't do it automatically, so I think it was just forgotten.
Comment 7 Jonathan Druart 2019-12-05 12:12:42 UTC
That makes it untranslatable.
Comment 8 Katrin Fischer 2019-12-05 12:20:10 UTC
(In reply to Jonathan Druart from comment #7)
> That makes it untranslatable.

Can you explain?
Comment 9 Jonathan Druart 2019-12-05 12:35:30 UTC
The strings in the template are:

"""
You already have at least one [% bibitemloo.forced_hold_level %] level hold on this title.
All further holds must be [% bibitemloo.forced_hold_level %] level.
"""

With forced_hold_level == "item" or "biblio".
Comment 10 Katrin Fischer 2019-12-07 08:58:04 UTC
Argh, thx for catching that.
Comment 11 Nick Clemens 2020-02-14 14:02:30 UTC
Created attachment 98946 [details] [review]
Bug 19718: (follow-up) Make messages translatable
Comment 12 Katrin Fischer 2020-02-14 21:52:33 UTC
Created attachment 99048 [details] [review]
Bug 19718: Show message if patron has existing holds on a title

To test:
 1 - Set a rule to allow multiple holds on a title
 2 - Place a single hold in the opac for a patron
 3 - Return to record and attempt place a second hold
 4 - Note there is no message but that you must match the type placed before (item or record level)
 5 - Don't place the hold
 6 - Apply patch
 7 - Attempt to place second hold again
 8 - Note there is a message informing you of which level hold you may place
 9 - Test with both item/record level holds and placing a single request or multiple requests

Signed-off-by: donnab <donna@bywatersolutions.com>

Signed-off-by: Katrin Fischer <katrin.fischer.83@web.de>
Comment 13 Katrin Fischer 2020-02-14 21:52:42 UTC
Created attachment 99049 [details] [review]
Bug 19718: (follow-up) Make messages translatable

Signed-off-by: Katrin Fischer <katrin.fischer.83@web.de>
Comment 14 Martin Renvoize 2020-02-17 11:32:00 UTC
Nice work everyone!

Pushed to master for 20.05
Comment 15 Joy Nelson 2020-03-05 01:38:06 UTC
enhancement not pushed to 19.11.x